#Programma dimostrativo dell'uso delle variabili statiche e dinamiche
			.data
s_N:		.asciiz "Quanti numeri vuoi inserire? "
s_Ins:		.asciiz	"Inserisci un numero: "
s_Ins5:		.asciiz	"Inserisci 5 numeri da cercare:\n"
s_Find:		.asciiz	"Cerco "
s_NoFound:		.asciiz	" Non trovato.\n"
s_YesFound:		.asciiz	" Trovato!\n"
s_Exit:		.asciiz	"That's All! Goodbye!\n"
s_ret:		.asciiz	"\n"

			# N: numero di elementi inseriti dall'utente
        	# DATI[]: array dinamico di interi di N elementi
        	# RICERCA[5]: cinque numeri da cercare, li memorizzo in 20 bytes
			#   all'inizion dell'area $gp da -0x8000($gp) a -0x8000($gp)+19

			# N <-> s0
			# DATI <-> s1    //inizio dell'array
			# RICERCA = $gp  //non occorre memorizzarlo esplicitamente
			.text
			.globl main
main:
			#
			#inserimento delll'array dei dati in cui cercare, la lunghezza e' arbitraria
			#
			li $v0, 4           # print "Quanti..."
			la $a0, s_N
			syscall

			li $v0, 5    		# N=getint();
			syscall
			move $s0, $v0

			sll	$t0,$s0,2		# DATI=malloc(N*4)
			sub $sp,$sp,$t0     # 	riservo N*4 byte all'inizio dello stack per
			move $s1, $sp       # 	memorizzare l'array, conservo l'inizio in s1

			li $t0, 0				# for (i=0;i<N;i++) , implemento i con $t0
			bge $t0, $s0, jnoins    #	se N<=0 allora non ci sono dati da ricevere
jcont:                              #	body for
				li $v0, 4           # print "Inserisci.."
				la $a0, s_Ins
				syscall

				li $v0, 5			# X=getint();  //uso direttamente $v0 al ritorno
				syscall             #			   //della syscall per implementare X

				sll $t1,$t0,2		# DATI[i]=X	   //uso $t1 per calcolare il puntatore
				add $t1,$s1,$t1		#			   //a DATI[i]
				sw $v0,0($t1)

			addi $t0,$t0,1			#   incremento il contatore
			blt $t0, $s0, jcont		#	se ci sono ancora numeri da ricevere, allora ciclo
									#   end for
jnoins:
            #
            # inserimento dei 5 numeri da cercare
            #
			li $v0, 4           # print "Inserisci altri 5 numeri..."
			la $a0, s_Ins5
			syscall

			#non occorre riservare nessuna area perche' l'intera area $gp
			#e' gia' disponibile

			li $t0, 0				# for (i=0;i<5;i++) , implemento i con $t0
									#	ci sono dati da ricevere, salto il primo controllo
jcont2:                             #	body for
				li $v0, 4           # print "Inserisci.."
				la $a0, s_Ins
				syscall

				li $v0, 5			# X=getint();  //uso direttamente $v0 al ritorno
				syscall             #			   //della syscall per implementare X

									# RICERCA[i]=X //uso $t1 per calcolare il puntatore
                                    #			   //a RICERCA[i], non occorre memorizzare
                                    # l'inizio di ricerca perche posso ricavarlo da $gp
				sll $t1,$t0,2		# $t1=i*4
				add $t1,$gp,$t1     # $t1=i*4+$gp
				sw $v0,-0x8000($t1) # l'indirizzo di RICERCA[i] e' $t1-0x8000= i*4+$gp-0x8000
									#   i*4 l'inizio dell'array

			addi $t0,$t0,1
			blt $t0, 5, jcont2		#	se ci sono ancora numeri da ricevere, allora ciclo
									#	end for

			#
            # cerco i caratteri da cercare
            # 	un ciclo for scandisce i numeri da cercare
            # 	un ciclo for piu- interno scandisce tutti i numeri in DATI
            # 	alla ricerca del numero giusto

			li $t0, 0				# for (i=0;i<5;i++) , implemento i con $t0
									#	ci sono dati da cercare, salto il primo controllo
jloop30:
				li $v0, 4           # print "Cerco "
				la $a0, s_Find
				syscall

	               					# $t2=RICERCA[i]
				sll $t1,$t0,2		# $t1=i*4
				add $t1,$gp,$t1     # $t1=i*4+$gp
				lw $t2,-0x8000($t1) # l'indirizzo di RICERCA[i] e' $t1-0x8000= i*4+$gp-0x8000
									#   i*4 l'inizio dell'array

				move $a0,$t2		# print $t2 //il numero da cercare
				li $v0, 1
				syscall

				li $t3, 0				# for (j=0;j<N;i++) , implemento j con $t3
				bge $t3,$s0	, jskip3	#	se non ci sono dati in cui cercare , salto il primo controllo
jloop3:
					sll $t4,$t3,2		# $t5=DATI[j]  //uso $t4 per calcolare il puntatore
					add $t4,$s1,$t4		#			   //a DATI[i]
					lw $t5,0($t4)

					bne $t5,$t2, jcont3	# se (DATI[j]<>RICERCA[i]) allora continua la ricerca

	       				li $v0,4        # altrimenti l'ho trovato, passo al prossimo numero da cercare
		       			la $a0, s_YesFound  # print "trovato"
    		   			syscall

    	   			j jskip3			# break, esco in anticipo dal ciclo
jcont3:
       			addi $t3,$t3,1
       			blt $t3,$s0, jloop3     #	se ci sono ancoda dati in cui cercare , ciclo

				# se arrivo qui vuol dire che non lo ho trovato
       			li $v0,4				# print "Non trovato"
       			la $a0, s_NoFound
       			syscall

jskip3:
			addi $t0,$t0,1
			blt $t0, 5, jloop30		#	end for
									#	se ci sono ancora numeri da cercare, allora ciclo

			li $v0, 4           # print "ciao!"
			la $a0, s_Exit
			syscall

			jr $ra
